package tacv.universe.environment.sensor;

import tacv.util.TacEventType;
import cz.agents.alite.common.entity.Entity;
import cz.agents.alite.common.event.Event;
import cz.agents.alite.environment.eventbased.EventBasedSensor;
import tacv.universe.environment.AgentScoutEnvironment;
import tacv.universe.environment.sensor.callback.AlarmCallback;

public class AlarmSensor extends EventBasedSensor {

    public AlarmSensor(AgentScoutEnvironment environment, Entity relatedEntity) {
        super(environment, relatedEntity);
    }

    public void registerAlarmCallback(long deltaTimeInMillis, AlarmCallback alarmCallback) {
        getEventProcessor().addEvent(TacEventType.SENSE_ALARM, this, null, alarmCallback, deltaTimeInMillis);
    }

    @Override
    public void handleEvent(Event event) {
        if (event.isType(TacEventType.SENSE_ALARM)) {
            AlarmCallback alarmCallback = (AlarmCallback) event.getContent();
            alarmCallback.senseAlarm(event.getTime());
        } else {
            super.handleEvent(event);
        }

    }
}
