package tacv.vis3d.layer;

import com.jme3.material.Material;
import com.jme3.scene.Spatial;
import com.jme3.texture.Texture;
import cz.agents.alite.vis3d.Vis3d;
import cz.agents.alite.vis3d.layer.Universe3DLayer;
import cz.agents.alite.vis3d.layer.Vis3DLayer;
import java.util.ArrayList;
import java.util.List;

public class Skybox3DLayer {

    public static Vis3DLayer create() {
        return new Universe3DLayer() {

            @Override
            protected List<Spatial> createSpatials(Vis3d vis) {
                List<Spatial> ret = new ArrayList<Spatial>();
                Spatial skybox = vis.getAssetManager().loadModel("models/skybox/skybox.j3o");
                Material skyMat = new Material(vis.getAssetManager(),
                        "Common/MatDefs/Misc/SimpleTextured.j3md");
                Texture skyTex = vis.getAssetManager().loadTexture("models/skybox/skybox_cubemap.png");
                skyMat.setTexture("ColorMap", skyTex);
                skybox.setMaterial(skyMat);
                skybox.setLocalScale(80);
                skybox.setLocalTranslation(90, 20, -80);
                ret.add(skybox);
                return ret;
            }
        };
    }
}
